/// <reference types="react" />
interface RegisterOptions {
    modeShadow: boolean;
    returnElement: boolean;
    hasReactRef: boolean;
    className: string;
    lazy: boolean;
}
type LazyReactComponentPromise = Promise<React.ComponentType<any>>;
type LazyReactComponentType = () => LazyReactComponentPromise;
type ReactComponentType = React.ComponentType<any> | LazyReactComponentType;
type ReactComponent = ReactComponentType & {
    componentProps?: Record<string, any>;
    propTypes?: Record<string, any>;
};
export declare function register(ReactComponent: ReactComponent, name: string, React: any, ReactDOM: any, options?: Partial<RegisterOptions>): typeof HTMLElement | void;
export {};
